﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FilterNumericData
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1.ActiveSheet.RowCount = 400;
            for (int i = 1; i <= 200; i++)
            {
                fpSpread1.ActiveSheet.Cells[i - 1, 0].Value = i;
            }
            for (int i = 200, val =1; i <= 400; i++, val++)
            {
                fpSpread1.ActiveSheet.Cells[i - 1, 0].Value = val;
            }

            FarPoint.Win.Spread.FilterListBehavior flb = new FarPoint.Win.Spread.FilterListBehavior();
            flb = FarPoint.Win.Spread.FilterListBehavior.Custom;

            FarPoint.Win.Spread.FilterColumnDefinition fcd = new FarPoint.Win.Spread.FilterColumnDefinition(0, flb);
            for (int r = 0; r < fpSpread1.ActiveSheet.RowCount; r++)
            {
                NumericFilter bwf = new NumericFilter(fpSpread1.ActiveSheet, (int)fpSpread1.ActiveSheet.Cells[r, 0].Value);
                fcd.Filters.Add(bwf);
            }
            FarPoint.Win.Spread.HideRowFilter hf = new FarPoint.Win.Spread.HideRowFilter(fpSpread1.ActiveSheet);
            hf.AddColumn(fcd);
            fpSpread1.ActiveSheet.RowFilter = hf;
        }
    }

    public class NumericFilter : FarPoint.Win.Spread.BaseFilterItem
    {

        private FarPoint.Win.Spread.SheetView sv = null;
        private int num;
        public NumericFilter()
        {
        }

        public NumericFilter(FarPoint.Win.Spread.SheetView sheetView, int val)
        {
            this.sv = sheetView;
            num = val;
        }

        public override string DisplayName
        {
            get
            {
                
                return num.ToString() ;
            }
        }

        public override FarPoint.Win.Spread.SheetView SheetView
        {
            set
            {
                sv = value;
            }
        }

        public bool IsFilteredIn(string value)
        {
            if ((!(value == null)
                        && value.Equals(num.ToString())))
            {
                return true;
            }
            return false;
        }

        public override bool ShowInDropDown(int columnIndex, int[] filteredInRowList)
        {
            if ((filteredInRowList == null))
            {
                return true;
            }
            int i;
            for (i = 0; (i
                        <= (filteredInRowList.Length - 1)); i++)
            {
                int row = filteredInRowList[i];
                string value = sv.GetText(row, columnIndex);
                if ((!(value == null)
                            && (value.Length > 0)))
                {
                    if (IsFilteredIn(value))
                    {
                        return true;
                    }
                }
            }
            return false;
        }

        public override int[] Filter(int columnIndex)
        {
            System.Collections.ArrayList list = new System.Collections.ArrayList();
            int[] returnList = null;
            int row;
            for (row = 0; (row
                        <= (sv.RowCount - 1)); row++)
            {
                string value = sv.GetText(row, columnIndex);
                if (IsFilteredIn(value))
                {
                    list.Add(row);
                }
            }
            if ((list.Count > 0))
            {
                returnList = new int[list.Count];

                list.CopyTo(returnList);
                list.Clear();
            }
            return returnList;
        }

        public override bool Serialize(System.Xml.XmlTextWriter w)
        {
            return true;
        }

        public override bool Deserialize(System.Xml.XmlNodeReader r)
        {
            return true;
        }
    }

}
